/**
 * @file
 * Functionality that provides style switching without page reloading.
 */

(function ($) {

Drupal.styleSwitcher = Drupal.styleSwitcher || {};

/**
 * Cookie plugin 1.0
 *
 * Copyright (c) 2006 Klaus Hartl (stilbuero.de)
 * Dual licensed under the MIT and GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 *
 * This function is the exact copy of D7's misc/jquery.cookie.js.
 */
Drupal.styleSwitcher.cookie=function(b,j,m){if(typeof j!="undefined"){m=m||{};if(j===null){j="";m.expires=-1}var e="";if(m.expires&&(typeof m.expires=="number"||m.expires.toUTCString)){var f;if(typeof m.expires=="number"){f=new Date();f.setTime(f.getTime()+(m.expires*24*60*60*1000))}else{f=m.expires}e="; expires="+f.toUTCString()}var l=m.path?"; path="+(m.path):"";var g=m.domain?"; domain="+(m.domain):"";var a=m.secure?"; secure":"";document.cookie=[b,"=",encodeURIComponent(j),e,l,g,a].join("")}else{var d=null;if(document.cookie&&document.cookie!=""){var k=document.cookie.split(";");for(var h=0;h<k.length;h++){var c=jQuery.trim(k[h]);if(c.substring(0,b.length+1)==(b+"=")){d=decodeURIComponent(c.substring(b.length+1));break}}}return d}};

/**
 * Given the style object, switches stylesheets.
 *
 * @param style
 *   A style array.
 */
Drupal.styleSwitcher.switchStyle = function (style) {
  // Update the cookie first.
  Drupal.styleSwitcher.cookie('styleswitcher[' + style.theme + ']', style.name, {
    path: Drupal.settings.basePath,
    // Number of days the cookie must live.
    expires: Drupal.settings.styleSwitcher.cookieExpire / 86400
  });

  // Now switch the stylesheet. Path is absolute URL with scheme.
  $('#styleswitcher-css').attr('href', style.path);

  // Cosmetic changes.
  Drupal.styleSwitcher.switchActiveLink(style.name);
};

/**
 * Switches active style link.
 *
 * @param styleName
 *   Machine name of the active style.
 */
Drupal.styleSwitcher.switchActiveLink = function (styleName) {
  $('.style-switcher').removeClass('active')
    .filter('[data-rel="' + styleName + '"]').addClass('active');
};

/**
 * Builds an overlay for transition from one style to another.
 *
 * @return
 *   Dom object of overlay.
 */
Drupal.styleSwitcher.buildOverlay = function () {
  var $overlay = $('<div>')
    .attr('id', 'style-switcher-overlay')
    .appendTo($('body'))
    .hide();

  return $overlay;
};

/**
 * Removes overlay.
 */
Drupal.styleSwitcher.killOverlay = function () {
  // This is more useful than just "$(this).remove()".
  $('#style-switcher-overlay').remove();
};

/**
 * Binds a switch behavior on links clicking.
 */
Drupal.behaviors.styleSwitcher = function (context) {
  // Set active link. It is not set from PHP, because of pages caching.
  var theme = Drupal.settings.styleSwitcher.theme;
  var activeStyle = Drupal.styleSwitcher.cookie('styleswitcher[' + theme + ']') || Drupal.settings.styleSwitcher.default;
  Drupal.styleSwitcher.switchActiveLink(activeStyle);

  $('.style-switcher:not(.styleswitcher-processed)', context).addClass('styleswitcher-processed').click(function () {
    var $link = $(this).blur();
    var name = $link.attr('data-rel');
    var style = Drupal.settings.styleSwitcher.styles[name];

    if (Drupal.settings.styleSwitcher.enableOverlay) {
      var $overlay = Drupal.styleSwitcher.buildOverlay();

      $overlay.fadeIn('slow', function () {
        Drupal.styleSwitcher.switchStyle(style);
        $overlay.fadeOut('slow', Drupal.styleSwitcher.killOverlay);
      });
    }
    else {
      Drupal.styleSwitcher.switchStyle(style);
    }

    return false;
  });
};

})(jQuery);
